//////////////////////////////////////////////////////////////////////////////
//
// (C) Copyright Ion Gaztanaga 2010-2012. Distributed under the Boost
// Software License, Version 1.0. (See accompanying file
// LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org/libs/interprocess for documentation.
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
//  (C) Copyright Ladislav Sopko, 3D Informatica s.r.l 2014
//  
//////////////////////////////////////////////////////////////////////////////

#if defined(_MSC_VER)&&(_MSC_VER>=1200)
#pragma once
#endif


#ifndef XW_IPC_IPC_HPP
#define XW_IPC_IPC_HPP


#include <xw-incl/ipc/fixable_robust_mutex.hpp>

namespace xw{ namespace ipc{
	/************************************************************************/
	/*  example of use                                                      */
	/************************************************************************/
	
	/*

	//normal mutex
	typedef xw::ipc::fixable_ipc_robust_named_mutex mutex_type_t;
	typedef boost::interprocess::scoped_lock<mutex_type_t> scoped_lock_type_t;

	//recursive mutex
	typedef xw::ipc::fixable_ipc_robust_named_recursive_mutex recursive_mutex_type_t;
	typedef boost::interprocess::scoped_lock<recursive_mutex_type_t> recursive_scoped_lock_type_t;

	//mutex_type_t myMutex(boost::interprocess::open_or_create, "my_named_mutex");  //<-- exception fixer !
	mutex_type_t myMutex(boost::interprocess::open_or_create, "my_named_mutex", IPC_MAKE_FIXER(xw::ipc::dummy_fixer));

	{   //lock in scope
		scoped_lock_type_t cslock(myMutex, boost::interprocess::try_to_lock);
		
		... working code ...

	}


	custom fixer and scoped lock

	xw::ipc::mutex_fixer_ptr_t fixer =  IPC_MAKE_FIXER(xw::ipc::dummy_fixer);
	fixable_scoped_lock_t __cslock(myMutexNormal, fixer);  //lock and fix it

	*/
}}  //xw::ipc
#endif